<?php
/// Автор сего безобразия: Anton Korzhov aka LoPaTa (statser@mail.ru)
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/// Скрипт отправляет средствами asterisk через модуль chan_dongle смс (в формате PDU) на 11-значные мобильные
/// номера в кодировке UCS-2 (UNICODE) как короткие (до 70 символов), так и длинные смс, разбивая их на части.
/// Формат команды: php -f [SCRIPT_PATH]/LPTsmses_to_pdus.php +79XXXXXXXXX 'TEXT_SMS' [debug]
/// Донглы выбираются из списка (см. ниже) при условии если они подключены и видны в asterisk.
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/// Скрипт рассчитан на локаль в системе UTF-8. Гарантий на работоспособность в другой локали нет (естественно), как
/// ее в принципе нет в условиях, отличных от моего использования. Удачи в начинаниях!
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/// Написано по статьям:
/// http://hardisoft.ru/soft/samodelkin-soft/otpravka-sms-soobshhenij-v-formate-pdu-teoriya-s-primerami-na-c-chast-1/
/// http://hardisoft.ru/soft/samodelkin-soft/otpravka-dlinnyx-sms-soobshhenij-v-formate-pdu/
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/// Преимущество данного решения:
/// Возможность отправлять СМС с сим-карты, используемой для звонков, в то время как тот же SMStools3 занимает
/// устройство (модем) полностью и asterisk уже не может подключиться к модему.
/// Бывает мобильные операторы предоставляют бесплатные пакеты СМС на выгодных "разговорных" тарифах, которыми грех
/// не воспользоваться, а стандартные средства asterisk не позволяют писать длинные СМС через chan_dongle, что ...
/// огорчает, порой даже очень.
/// Как показала практика, даже при отправке СМС во время разговора на конкретной сим-карте ошибок не возникало и СМС
/// доходили. Но тем не менее в скрипте заложена логика выбирать для отправки СМС донгл, находящийся в состоянии
/// ожидания (на момент опроса донглов).
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// массивы со списками донглов
$dongle_sp_all=array("TELE2-1000","TELE2-2000","TELE2-3000","TELE2-4000"); // Список всех донглов - МЕНЯЕМ НА СВОИ !!
$dongle_sp_limited=FALSE; // Функция вырезана, используется в другом проекте
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/// Ключевое слово, выводящееся в начале сообщения об ошибке при выполнения скрипта:
$err_key="Ошибка ".basename(__FILE__).": ";
/// Защищаемся от повторного запуска скрипта, мало ли что...
if(!flock($lock_file = fopen(__FILE__.".lock", 'w'), LOCK_EX | LOCK_NB))
die($err_key."Этот скрипт уже запущен!\nСгинь демон!\n");
/// Признак работающего (и свободного) донгла (при вызове команды "dongle show devices"), содержащийся в строке:
$priznak="Free";
/// Признак подтверждения модемом задания на отправку сообщения/части сообщения:
$prizn_s_sms="SMS queued for send with id";
/// Количество попыток запроса при получении неудачного результата
$itter=3;
/// Ключевое слово, выводящееся в начале сообщения при успешном выполнении скрипта:
$good_key="Подтверждение ".basename(__FILE__).": ";
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/// Описываем функции
function find_active_dongle($dongle_sp_limitedf, $dongle_sp_allf, $priznakf)
{
	$ex=FALSE;
	if ($dongle_sp_limitedf!=FALSE)
	{
		for ($i=0; $i<count($dongle_sp_limitedf); $i+=1)
		{
	                $grep_v=shell_exec("sudo asterisk -rx 'dongle show devices' | grep -E '".$dongle_sp_limitedf[$i].".*".$priznakf."'");
			sleep(3);
			if (strlen($grep_v)>0 && $ex==FALSE)
			{
				$ex=TRUE;
				return $dongle_sp_limitedf[$i];
			}
		}
	}
        if ($ex==FALSE)
        {
	        for ($i=0; $i<count($dongle_sp_allf); $i+=1)
	        {
	                $grep_v=shell_exec("sudo asterisk -rx 'dongle show devices' | grep -E '".$dongle_sp_allf[$i].".*".$priznakf."'");
	                sleep(3);
	                if (strlen($grep_v)>0 && $ex==FALSE)
	                {
	                        $ex=TRUE;
	                        return $dongle_sp_allf[$i];
			}
	  	}
	}
	if ($ex==FALSE)
	{
		echo $err_key."Отсутствуют работающие донглы!\n";
		exit;
	}
}
function find_SMS_SCA_aster($dongle_name, $itterf)
{
	$step=0;
	$step_2=0;
	do {
		$grep_SCA_fr_dongle_aster=shell_exec("sudo asterisk -rx 'dongle show device state ".$dongle_name."' | grep 'SMS Service Center'");
		$step+=1;
		sleep(3);
	} while (strlen($grep_SCA_fr_dongle_aster)<1 && $step<$itterf);
	if (strlen($grep_SCA_fr_dongle_aster)==0)
	{
                echo $err_key."Не найден номер SMS Service Center!\n";
                exit;
	}
        do {
		$num_SMS_SCA_aster=substr($grep_SCA_fr_dongle_aster, strpos($grep_SCA_fr_dongle_aster, "+" , 0)+1, 11);
		$step_2+=1;
		sleep(3);
	} while (strlen($num_SMS_SCA_aster)!=11 && $step_2<$itterf);
		if (strlen($num_SMS_SCA_aster)!=11)
		{
			echo $err_key."Некорректный номер SMS Service Center!\n";
			exit;
		}
	return $num_SMS_SCA_aster;
}
function real_SCA_to_PDU_SCA($num)
{
	if ((strlen($num) % 2 ) != 0){$num=$num."F";}
	$newStr = "";
	for ($i=0; $i<strlen($num); $i+=2)
	{
		$cutStr = substr(substr($num,$i,2),1,1).substr(substr($num,$i,2),0,1);
		$newStr=$newStr.$cutStr;
	}
		if (strlen($newStr)!=12)
		{
			echo $err_key."Номер SMS Service Center не в международном формате (91h)!\n";
			exit;
		}
		else
		{
			$newStr="91".$newStr;
			if (($c_bit=strlen($newStr)/2) < 10)
			{
				$newStr="0".$c_bit.$newStr;
			}
			else
			{
				$newStr=$c_bit.$newStr;
			}
			return $newStr;
		}
}
function real_TP_DA_to_PDU_TP_DA($num1)
{
	$num1=substr($num1, strpos($num1, "+" , 0)+1, 11);
        $num_without_plus=$num1;
	if ((strlen($num1) % 2 ) != 0){$num1=$num1."F";}
        $newStr = "";
        for ($i=0; $i<strlen($num1); $i+=2)
        {
                $cutStr = substr(substr($num1,$i,2),1,1).substr(substr($num1,$i,2),0,1);
                $newStr=$newStr.$cutStr;
        }
                if (strlen($newStr)!=12)
                {
                        echo $err_key."Номер получателя не в международном формате (91h)!\n";
                        exit;
                }
                else
                {
                        $newStr="91".$newStr;
			$length_num_res=strtoupper(dechex(strlen($num_without_plus)));
			if (strlen($length_num_res) == 1)
                        {
                                $length_num_res="0".$length_num_res;
                        }
                        $newStr=$length_num_res.$newStr;
                        return $newStr;
                }
}
function send_first_retry($boolean_send)
{
	if ($boolean_send==TRUE)
	{
		echo "Проблема: Донгл не вернул подтверждение отправки СМС (ее части), повторная попытка...\n";
	}
	else
	{
		echo "Попытка отправить СМС (ее часть)...\n";
	}
}
////////////////////////////////////////////////////////////////////////// Понеслось...
if (count($_SERVER['argv'])>=3)
/// Не дошли руки до проверки входных параметров, и наверно и не дойдут - вводите правильно аргументы! или допиливайте скрипт, косяков тут хватает.
{
// Таймаут между смс
//sleep(10); // Разремить если скрипт используется для массовой рассылки и вызов скрипта осуществляется поочередно - таймаут необходим, донглы и так работают нестабильно, а без таймаута виснут напрочь!
        $mobile_num=$_SERVER['argv'][1];
        $text_sms=$_SERVER['argv'][2];
	if (isset($_SERVER['argv'][3]) && $_SERVER['argv'][3]=='debug'){$debug=TRUE;}
	else {$debug=FALSE;}
	$TP_DA=real_TP_DA_to_PDU_TP_DA($mobile_num);
	$TP_PID="00";
	$TP_DCS="08";
	$TP_VP="";
	if ($debug){echo "#############################################################################################\n\$TP_DA=".$TP_DA."\n"."\$TP_PID=".$TP_PID."\n"."\$TP_DCS=".$TP_DCS."\n"."\$TP_VP=".$TP_VP."\n";}
	if (mb_strlen($text_sms, 'utf-8') <= 70) // Короткое сообщение в UNICODE
	{
		$step_3=0;
		do {
			if ($debug){send_first_retry($step_3>0);}
			$dongle=find_active_dongle($dongle_sp_limited, $dongle_sp_all, $priznak);
		        $real_SCA=find_SMS_SCA_aster($dongle, $itter);
		        $SCA=real_SCA_to_PDU_SCA($real_SCA);
			$PDU_Type="01";
			$TP_MR="00";
			$TP_UDL=strtoupper(dechex(mb_strlen($text_sms, 'utf-8')*2));
			if (strlen($TP_UDL) == 1){$TP_UDL="0".$TP_UDL;}
			$UDH="";
			$TP_UD=strtoupper(bin2hex(mb_convert_encoding($text_sms,"UCS2","UTF-8")));
			$TPDU=$PDU_Type.$TP_MR.$TP_DA.$TP_PID.$TP_DCS.$TP_VP.$TP_UDL.$UDH.$TP_UD;
			$SMS=$SCA.$TPDU;
			$command_send_single="sudo asterisk -rx 'dongle pdu ".$dongle." ".$SMS."'\n";
			if ($debug){echo "\$SCA=".$SCA."\n"."\$PDU_Type=".$PDU_Type."\n"."\$TP_MR=".$TP_MR."\n"."\$TP_UDL=".$TP_UDL."\n"."\$UDH=".$UDH."\n"."\$TP_UD=".$TP_UD."\n"."\$TPDU=".$TPDU."\n"."\$SMS=".$SMS."\n"."Команда asterisk=".$command_send_single."\n";}
			$result_send_single=shell_exec($command_send_single);
			$step_3+=1;
			sleep(3);
		} while ((strpos($result_send_single, $prizn_s_sms)===FALSE) && $step_3<$itter);
		if (strpos($result_send_single, $prizn_s_sms)===FALSE)
		{
			echo $err_key."Донгл ".$dongle." не возвращает подтверждение отправки SMS!\n";
			exit;
		}
		else
		{
			echo $good_key."Донгл ".$dongle." подтвердил отправку СМС!\n";
			exit;
		}
	}
	else // Длинное сообщение в UNICODE
	{
		$PDU_Type="41";
                $UDHL="05";
                $IEI="00";
                $IEDL="03";
		$USC2_symlen=67;
		$dongle=find_active_dongle($dongle_sp_limited, $dongle_sp_all, $priznak);
		$IED1=strtoupper(dechex(rand(16, 255)));
		if ($debug){echo "\$PDU_Type=".$PDU_Type."\n"."\$UDHL=".$UDHL."\n"."\$IEI=".$IEI."\n"."\$IEDL=".$IEDL."\n"."Максимальная длина текста в 'под'-сообщении: ".$USC2_symlen."\n"."\$IED1=".$IED1."\n";}
        	for ($numm=0; $numm<(floor(mb_strlen($text_sms, 'utf-8')/$USC2_symlen)); $numm+=1)
        	{
	                $real_SCA=find_SMS_SCA_aster($dongle, $itter);
	                $SCA=real_SCA_to_PDU_SCA($real_SCA);
			$text[$numm]=mb_substr($text_sms, $numm*$USC2_symlen, $USC2_symlen,'utf-8');
			$TP_MR[$numm]=$numm;
                        if (strlen(strtoupper(dechex($TP_MR[$numm]))) == 1){$TP_MR[$numm]="0".strtoupper(dechex($TP_MR[$numm]));}
			$IED3[$numm]=$numm+1;
			if (strlen(strtoupper(dechex($IED3[$numm]))) == 1){$IED3[$numm]="0".strtoupper(dechex($IED3[$numm]));}
			$TP_UDL[$numm]=strtoupper(dechex(mb_strlen($text[$numm], 'utf-8')*2+$UDHL+1));
                	if (strlen($TP_UDL[$numm]) == 1){$TP_UDL[$numm]="0".$TP_UDL[$numm];}
			$TP_UD[$numm]=strtoupper(bin2hex(mb_convert_encoding($text[$numm],"UCS2","UTF-8")));
			if ($debug){echo "\$text[".$numm."]=".$text[$numm]."\n"."\$TP_MR[".$numm."]=".$TP_MR[$numm]."\n"."\$IED3[".$numm."]=".$IED3[$numm]."\n"."\$TP_UDL[".$numm."]=".$TP_UDL[$numm]."\n"."\$TP_UD[".$numm."]=".$TP_UD[$numm]."\n";}
			if (($numm+1)==(floor(mb_strlen($text_sms, 'utf-8')/$USC2_symlen)))
			{
				$text[($numm+1)]=mb_substr($text_sms, ($numm+1)*$USC2_symlen, mb_strlen($text_sms, 'utf-8')-$numm*$USC2_symlen,'utf-8');
				$TP_MR[$numm+1]=$numm+1;
	                        if (strlen(strtoupper(dechex($TP_MR[$numm+1]))) == 1){$TP_MR[$numm+1]="0".strtoupper(dechex($TP_MR[$numm+1]));}
				$IED3[($numm+1)]=$numm+2;
				if (strlen(strtoupper(dechex($IED3[($numm+1)]))) == 1){$IED3[($numm+1)]="0".strtoupper(dechex($IED3[($numm+1)]));}
        	                $TP_UDL[$numm+1]=strtoupper(dechex(mb_strlen($text[$numm+1], 'utf-8')*2+$UDHL+1));
	                        if (strlen($TP_UDL[$numm+1]) == 1){$TP_UDL[$numm+1]="0".$TP_UDL[$numm+1];}
				$IED2=strtoupper(dechex(count($text)));
				if (strlen($IED2) == 1){$IED2="0".$IED2;}
				$TP_UD[$numm+1]=strtoupper(bin2hex(mb_convert_encoding($text[$numm+1],"UCS2","UTF-8")));
				if ($debug){echo "\$text[".($numm+1)."]=".$text[($numm+1)]."\n"."\$TP_MR[".($numm+1)."]=".$TP_MR[$numm+1]."\n"."\$IED3[".($numm+1)."]=".$IED3[($numm+1)]."\n"."\$TP_UDL[".($numm+1)."]=".$TP_UDL[$numm+1]."\n"."\$IED2=".$IED2."\n"."\$TP_UD[".($numm+1)."]=".$TP_UD[($numm+1)]."\n";}
			}
	        }
		$tic=0;
		for ($im=0; $im<count($text); $im+=1)
		{
			$step_4=0;
		        do {
			if ($debug){send_first_retry($step_4>0);}
			$UDH=$UDHL.$IEI.$IEDL.$IED1.$IED2.$IED3[$im];
		        $TPDU=$PDU_Type.$TP_MR[$im].$TP_DA.$TP_PID.$TP_DCS.$TP_VP.$TP_UDL[$im].$UDH.$TP_UD[$im];
		        $SMS=$SCA.$TPDU;
	                $command_send_multi="sudo asterisk -rx 'dongle pdu ".$dongle." ".$SMS."'\n";
	                if ($debug){echo "\$SCA=".$SCA."\n"."\$UDH[".$im."]=".$UDH."\n"."\$TPDU[".$im."]=".$TPDU."\n"."\$SMS[".$im."]=".$SMS."\n"."Команда для ".($im+1)." части сообщения: ".$command_send_multi."\n";}
	                $result_send_multi=shell_exec($command_send_multi);
			sleep(3);
			$step_4=$step_4+1;
			} while ((strpos($result_send_multi, $prizn_s_sms)===FALSE) && $step_4<$itter);
			if (strpos($result_send_multi, $prizn_s_sms)===FALSE)
	                {
	                        echo $err_key."Донгл ".$dongle." не возвращает подтверждение отправки части SMS!\n";
	                        exit;
	                }
	                else
	                {
	                        if ($debug){echo "Донгл ".$dongle." подтвердил отправку части СМС!\n";}
	                }
			$tic=$tic+1;
		}
		echo $good_key."Донгл ".$dongle." отправил все части мульти-SMS!\n";
                exit;
	}
}
else {echo $err_key."Недостаточно аргументов для отправки СМС!\n";}
?>
